#include "BP_Addons/scripts/BP_Common_Map.cpp"
#include "scripts/MT/MT_Common_Shared.cpp"

namespace MT
{
	//------------------------------------------------------------------------------------------------------------------------
	void NewGame()
	{
		BP::NewGame();
		
		//Setup one time only on game start
		if (!BP::GameVar::HasKey(GV_KEY_SYSTEM))
		{
			BP::GameVar::SetInt(GV_KEY_SYSTEM, 0);
			BP::GameVar::SetInt(GV_KEY_GAME_FLAGS, 0);
			BP::GameVar::SetString(GV_KEY_STARTMAP, PATH_MAP_START); //for standalone mod
			Sys.Print("--------------------------------------------------------------------------------------------------------------------------------");
			Sys.Warning("Mayahem Temple v" + VERSION);
			Sys.Warning("By: BehemothProgrammer");
			Sys.Print("--------------------------------------------------------------------------------------------------------------------------------");
		}
		else //NewGame
		{
			//Reset GameVars
			BP::GameVar::SetInt(GV_KEY_GAME_FLAGS, 0);
		}
	}
	//------------------------------------------------------------------------------------------------------------------------
	void OnMapStart(kActor@ instigator)
	{
		BP::MapStart();
		
		//Make sure player starts on the first map
		bool hasGameStarted = BP::GameVar::GetIntFlag(GV_KEY_GAME_FLAGS, GF_GAMESTARTED);
		if (!hasGameStarted)
		{
			if (Game.GetCurrentMapID() != MAP_MT_START)
			{
				Player.Lock();
				Game.ChangeMap(PATH_MAP_START);
				Game.HaltMapScript(SCRIPT_MAP_COMMON_START);
				BP::Wait(); //Need to wait to make this script no longer continue to execute
			}
			
			BP::GameVar::SetIntFlag(GV_KEY_GAME_FLAGS, GF_GAMESTARTED);
		}
					
		Game.CallDelayedMapScript(SCRIPT_MAP_MT_TICK, instigator, 0.0f);
	}
	//------------------------------------------------------------------------------------------------------------------------
	void OnMapTick(kActor@ instigator)
	{
		BP::Input::Tick();
	}
	//------------------------------------------------------------------------------------------------------------------------
}

//------------------------------------------------------------------------------------------------------------------------
// MT Map Tick
//------------------------------------------------------------------------------------------------------------------------
$script 60000 //SCRIPT_MAP_MT_TICK
{
	MT::OnMapTick(instigator);
	
	$restart;
}
//------------------------------------------------------------------------------------------------------------------------
