#include "scripts/MT/MT_Common_Map.cpp"

//Tag IDs
//2016: Checkpoint (Temple of Time Warp)
//1000: Start Warp
//1001: Temple of Time Warp
//1002: Top of Temple Warp
//1003: EventLink 1
//1004: Statue Enemies 1
//1005: Event Link 2
//1006: Drop Enemies 1
//1007: Birds 1
//1008: Drop Enemies 2
//1009: Drop Enemies 3
//1010: Trex, Raptor Enemies
//1011: Drop Enemies 4
//1012: Birds 2
//1013: Event Link 7,8 
//1014: Mantis
//1015: Door Temple of Time
//1016: side Mantises
//1017: Camera LookAt Point
//1018: Cinema Forcefield
//1019: 
//1020: Cinema Player Position
//1021: Start Message
//1022: Event Link 3
//1023: Event Link 4
//1024: Event Link 6
//1025: Event Link 5
//1026: Event Link 9
//1027: Campaigner
//1028: Point Blocker
//1029: Event Link 10 - Campaigner killed
//1030: Cinema Player Position
//1031: Event Link 11 - Chrono
//1032: Campaigners Health dummy actor
//1033: Chrono Pieces


kActor@ camLookAt;
kActor@ cinemaForceField;
kActor@ cinemaPlayerPos;
kActor@ campaigner;
kActor@ campaignerHealth;
kActor@ campaignerDoorBlocker;
kActor@ cinemaCampPlayerPos;

//------------------------------------------------------------------------------------------------------------------------
// SCRIPT_MAP_COMMON_START
//------------------------------------------------------------------------------------------------------------------------
$script 0
{
	MT::OnMapStart(instigator);
		
	@campaigner = World.GetActorByTID(1027);
	@campaignerDoorBlocker = World.GetActorByTID(1028);
	@cinemaCampPlayerPos = World.GetActorByTID(1030);
	@campaignerHealth = World.GetActorByTID(1032);
	World.FloodMatchingAreaFlags(campaignerDoorBlocker.SectorIndex(), AAF_BLOCK, false);
	if (BP::Actor::Exists(campaigner))
		BP::Actor::HideAI(campaigner);
	
	@camLookAt = World.GetActorByTID(1017);
	@cinemaForceField = World.GetActorByTID(1018);
	cinemaForceField.Flags() |= AF_NODRAW;
	@cinemaPlayerPos = World.GetActorByTID(1020);
	World.TriggerActorsByTID(instigator, 1021); //Start Message
	Game.CallDelayedMapScript(MT::SCRIPT_MAP_COMMON_TICK, instigator, 0);
	
	const int areaID = Player.Actor().AreaID();
	int arg6 = World.GetAreaArg(areaID, 5);
	if (arg6 != 32000)
		BP::Music::Play(MT::PATH_MUSIC_MAYAHEM_TEMPLE);
	else
		BP::Music::Stop();
	
	if (Player.HasWeapon(TW_WEAPON_CHRONO))
	{
		Player.GiveWeapon(TW_WEAPON_CHRONO, 3);
	}
}
//------------------------------------------------------------------------------------------------------------------------
// SCRIPT_MAP_COMMON_TICK
//------------------------------------------------------------------------------------------------------------------------
$script 1
{
	//Check if campaigner warped outside of battle area
	if (BP::Actor::Exists(campaigner) and !BP::Actor::IsHidden(campaigner))
	{
		if (campaigner.Origin().x >= -9523.200195)
		{
			campaigner.MoveToPosition(-10178.559570, campaigner.Origin().y);
		}
	}
	$restart;
}
//------------------------------------------------------------------------------------------------------------------------
// N Picked up
//------------------------------------------------------------------------------------------------------------------------
$script 10000
{
	Game.PrintLine("" + BP::Inventory::Count(0) + " out of " + " 7", 0);
}
//------------------------------------------------------------------------------------------------------------------------
// Local Teleport To Temple of Time
//------------------------------------------------------------------------------------------------------------------------
$script 10001
{
	if ((instigator.Flags() & AF_ENTEREDAREAEVENT) == 0)
	{
		if (BP::Inventory::Count(0) >= 7)
		{
			BP::Music::Stop();
			PlayLoop.StartWarp(instigator, 1001, 120);
		}
		else
		{
			Game.PrintLine(BP::Game::GetLocalText(1), 0, 300);
		}
	}
}
//------------------------------------------------------------------------------------------------------------------------
// Enter Campaigner Start Area
//------------------------------------------------------------------------------------------------------------------------
$script 10002
{
	if ((instigator.Flags() & AF_ENTEREDAREAEVENT) == 0 and BP::Actor::Exists(campaigner) and BP::Actor::IsHidden(campaigner))
	{
		BP::Music::Stop();
		World.FloodMatchingAreaFlags(campaignerDoorBlocker.SectorIndex(), AAF_BLOCK, true);
		BP::Cinema::Start(instigator, 10002, CampaignerAppearsCinemaFinished);
		BP::Actor::ShowAI(campaigner);
		BP::Cinema::ShowPlayer(cinemaCampPlayerPos, anim_aiStanding, TV_KNIFE);
		Camera.SetLookAtActor(campaigner);
		BP::Cinema::CameraMove(instigator, kVec3(-9939, -78, -606), kVec3(-9681, -481, -1050), 6.0);
		BP::WaitUntil(BP::Cinema::IsCameraMoveFinished);
		BP::Cinema::Stop();
	}	
}
//------------------------------------------------------------------------------------------------------------------------
void CampaignerAppearsCinemaFinished(const bool userInterrupted)
{
	PlayLoop.TagActorForBossBar(campaignerHealth);
	BP::Wait(0.5);
	BP::GameVar::SetIntFlag(MT::GV_KEY_CHRONOPIECES, (1 << 6) | (1 << 7)); //give chrono pieces 7 and 8
	World.TriggerActorsByTID(Player.Actor().CastToActor(), 1033); //Show Chrono Pieces 1 to 6
}
//------------------------------------------------------------------------------------------------------------------------
// Campaigner Killed
//------------------------------------------------------------------------------------------------------------------------
$script 10003
{
	PlayLoop.RemoveBossActor();
	BP::Wait(7.0);
	BP::WaitUntil(BP::Cinema::IsFinished);
	BP::Cinema::HidePlayer();
	BP::Music::Stop();
	Game.StopMusic();
	BP::Cinema::StartCustom(CMF_LOCK_PLAYER, 74.0f);
	Camera.SetLookAtActor(camLookAt);
	Game.PlaySound("sounds/shaders/mastersword.ksnd");
	cinemaForceField.Flags() &= ~AF_NODRAW;
	BP::Cinema::CameraMove(instigator, kVec3(-10304, -513, -1076), kVec3(-10925, -748, 134), 11.0);
	BP::Wait(0.5);
	BP::Cinema::ShowPlayer(cinemaPlayerPos, anim_aiStanding, TV_KNIFE);
	BP::Music::Stop();
	Game.StopMusic();
	delay(11.5f);
	Game.Restart();
}
//------------------------------------------------------------------------------------------------------------------------
// Chrono Pickup
//------------------------------------------------------------------------------------------------------------------------
$script 10004
{
	if (!Player.HasWeapon(TW_WEAPON_CHRONO))
	{
		Player.Actor().PlaySoundWithLookupID(389);
		Player.GiveWeapon(TW_WEAPON_CHRONO, 3);
		Game.PrintLine("$str_156", 0);
	}
}
//------------------------------------------------------------------------------------------------------------------------
